open BatchFun

functor Make(M : ARG) = struct

    table listeners : {Chan : channel ($(map fst M.cols))}

    fun wall () =
        ch <- channel;
        dml (INSERT INTO listeners (Chan) VALUES ({[ch]}));

        inps <- foldR [colMeta] [fn r => transaction ($(map snd r))]
                (fn [nm :: Name] [p :: (Type * Type)] [rest :: {(Type * Type)}] [[nm] ~ rest] m acc =>
                    s <- m.NewState;
                    r <- acc;
                    return ({nm = s} ++ r))
                (return {})
                [M.cols] M.fl M.cols;

        seen <- Dlist.create;

        let
            fun reallyAdd vs =
                queryI (SELECT * FROM listeners)
                (fn r => send r.Listeners.Chan vs)

            fun add () =
                vs <- foldR2 [colMeta] [snd] [fn r => transaction ($(map fst r))]
                             (fn [nm :: Name] [p :: (Type * Type)] [rest :: {(Type * Type)}]
                                              [[nm] ~ rest] m s acc =>
                                 v <- m.ReadState s;
                                 r <- acc;
                                 return ({nm = v} ++ r))
                             (return {})
                             [M.cols] M.fl M.cols inps;
                rpc (reallyAdd vs)

            fun listen () =
                vs <- recv ch;
                Monad.ignore (Dlist.append seen vs);
                listen ()
        in
            return <xml><body onload={listen ()}>
              <h2>Seen so far</h2>

              <table>
                <tr>
                  {foldRX [colMeta] [_]
                          (fn [nm :: Name] [p :: (Type * Type)] [rest :: {(Type * Type)}]
                                           [[nm] ~ rest] m =>
                              <xml><th>{[m.Nam]}</th></xml>)
                          [M.cols] M.fl M.cols}
                </tr>
                {Dlist.render (fn vs _ =>
                                  <xml><tr>
                                    {foldRX2 [colMeta] [fst] [_]
                                             (fn [nm :: Name] [p :: (Type * Type)] [rest :: {(Type * Type)}]
                                                              [[nm] ~ rest] m v =>
                                                 <xml><td>{m.Show v}</td></xml>)
                                             [M.cols] M.fl M.cols vs}
                                  </tr></xml>) seen}
              </table>

              <h2>Add a row</h2>

              <table>
                {foldRX2 [colMeta] [snd] [_]
                 (fn [nm :: Name] [p :: (Type * Type)] [rest :: {(Type * Type)}]
                                  [[nm] ~ rest] m s =>
                     <xml><tr> <th>{[m.Nam]}:</th> <td>{m.Widget s}</td> </tr></xml>)
                 [M.cols] M.fl M.cols inps}
                <tr> <th/> <td><button value="Send" onclick={add ()}/></td> </tr>
              </table>
            </body></xml>
        end

    fun main () = return <xml><body>
      <form><submit value="View the Wall" action={wall}/></form>
    </body></xml>
end
